#ifndef __spatialindex_rbtree_h
#define __spatialindex_rbtree_h

#include "RBNode.h"

namespace SpatialIndex
{

	class RBTree : public Tools::ISerializable
	{
	public:
		RBTree();
		~RBTree();
		void insert(RBNode * & , RBNode * );
		void printTree(RBNode *, int);
		void leftRot(RBNode * &, RBNode *);
		void rightRot(RBNode * &, RBNode *);
		void rbInsert(RBNode * &, RBNode *);
		RBNode * successor(RBNode *);
		void rbDelete(RBNode * & , RBNode * );
		void rbFix(RBNode * & , RBNode * );
		RBNode * search(RBNode *, long);
		void removeSentinel(RBNode * p);
		COLOR colorOf(RBNode * p);
		void buildHashes(RBNode*, byte**);
		void showTree();
		void bulkloadTree(long* keys, long* pid,  int* nodeid, byte** indigests, long size);

		virtual unsigned long getByteArraySize();
		virtual unsigned long loadFromByteArray(byte* const data);
		virtual void storeToByteArray(unsigned long& len, byte** data);
		virtual void writeNode(RBNode* node, byte** buffer, unsigned long& dataLength);
		virtual void writeTree(byte** buffer, unsigned long& dataLength);
		virtual RBNode* readNode(byte*& buffer);
		virtual void readTree(byte* buffer);
		virtual void storeToFile(char* file);
		virtual void loadFromFile(char* file);


		RBNode* m_root;
		RBNode* nil;
		byte* m_treeDigest;
		int m_id;
		int m_rootID;
		clock_t m_c0,m_c1;
		double m_cputime;
		long m_hashComputed;
		friend class RBNode;
	};	
}
#endif /*__spatialindex_rbtree_h*/
