// Spatial Index Library
//
// Copyright (C) 2002 Navel Ltd.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Contact information:
//  Mailing address:
//    Marios Hadjieleftheriou
//    University of California, Riverside
//    Department of Computer Science
//    Surge Building, Room 310
//    Riverside, CA 92521
//
//  Email:
//    lifeifei@cs.bu.edu, mhadji@gmail.com

#include <tools/Tools.h>

#include <set>

using namespace std;

#define INSERT 1
#define DELETE 0
#define QUERY 2
#define RANGE 1000000

class Point 
{
public:
	double m_xmin, m_xmax;

	Point(double x1, double x2)
	{
		m_xmin = (x1 < x2) ? x1 : x2;
		m_xmax = (x1 > x2) ? x1 : x2;
	}
};

int main(int argc, char** argv)
{
	if (argc != 5)
	{
		cerr << "Usage: " << argv[0] << " data_file update_ratior start_id database_size" << endl;
		return -1;
	}

	ifstream fin(argv[1]);
	if (! fin)
	{
		cerr << "Cannot open data file " << argv[1] << "." << endl;
		return -1;
	}

	unsigned long startid = atol(argv[3]);
	double updateRatio = atof(argv[2]);
	unsigned long database_size=atol(argv[4]);
	int op;
	unsigned long id, x, y;
	map<unsigned long, unsigned long> data;
	unsigned long cc=0;

	while (fin)
	{
		fin >> op >> id >> x >> y;
		//if (! fin.good()) continue; // skip newlines, etc.
		data.insert(pair<unsigned long, unsigned long>(id, x));	
		cc++;
	}
	cerr<<cc<<endl;	
	unsigned long numberOfupdates = (unsigned long)(updateRatio*(double)database_size);
	cerr<<updateRatio<<endl;
	cerr<<data.size()<<endl;
	cerr<<numberOfupdates<<endl;
	map<unsigned long, unsigned long>::iterator it = data.find(startid);
	unsigned long i=0;
	for (it,i;i<numberOfupdates;i++,it++)
		cout << INSERT <<" "<<(*it).first << " "<<(*it).second<<" "<<(*it).second<<endl;
	return 0;
}
